#!/usr/bin/env python

import sys
import os.path

from PyQt4.Qt import *

# Set a specified environment variable with a directory name.
def setEnvironment(env, var_name, dir_name):
    # Convert the relative directory name to an absolute one.
    dir = os.path.join(os.path.dirname(os.path.abspath(__file__)), dir_name)

    # Remove any existing value so that we have a controlled environment.
    idx = env.indexOf(QRegExp("^%s=.*" % var_name, Qt.CaseInsensitive))

    if idx >= 0:
        env.removeAt(idx)

    env << "%s=%s" % (var_name, dir)


app = QApplication(sys.argv)

# Tell Qt Designer where it can find the directory containing the plugins and
# Python where it can find the widgets.
env = QProcess.systemEnvironment()
setEnvironment(env, "PYQTDESIGNERPATH", "plugins")
setEnvironment(env, "PYTHONPATH", "widgets")

# Start Designer.
designer = QProcess()
designer.setEnvironment(env)

designer_bin = QLibraryInfo.location(QLibraryInfo.BinariesPath)

if sys.platform == "darwin":
    designer_bin.append("/Designer.app/Contents/MacOS/Designer")
else:
    designer_bin.append("/designer")

designer.start(designer_bin)
designer.waitForFinished(-1)

sys.exit(designer.exitCode())
